/*
$Header: /home/CVSrepository/xconcordancer/xconcordancer.h,v 1.1.1.1 2000/04/29 20:49:00 ralph Exp $
$Author: ralph $
$Locker:  $
$State: Exp $
$Log: xconcordancer.h,v $
Revision 1.1.1.1  2000/04/29 20:49:00  ralph
initial import of Motif GUI concordancer into CVS

*/

#ifndef XCONCORDANCER_HDR
#define XCONCORDANCER_HDR

#define MAXBFRSZ  80 //max size of word holding buffer
#define FILESEGMENT  512 //length of input file to read at one time
#define EXTENSIONLEN 5   //additional length to add to filename buffer for .wds, .abc file extensions.

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/Separator.h>
#include <Xm/BulletinB.h>
#include <Xm/ToggleB.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/Scale.h>
#include <Xm/Separator.h>
#include <Xm/MessageB.h>
#include <X11/Shell.h>

#include <new.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "standard.h"
#include "word.h"
#include "alphalst.h"
#include "RandRbig2.xpm"

/*~~~~~ Various Constants Sizes, locations, etc.:  ~~~~~*/
const int TOPLEVEL_HEIGHT=630;  //was 560 before output information
const int TOPLEVEL_WIDTH=400;
const int HELPSHELL_WIDTH=300;
const int HELPSHELL_HEIGHT=560;
const int LABEL_PIXMAP_YLOC=215;
const int LABEL_PIXMAP_XLOC=300;
const int BUTTON_HELP_YLOC=10;
const int BUTTON_HELP_XLOC=330;
const int YLOCATOR=20;  //with the addition of a help button
const int XLOCATOR=5;
const int LABEL_INPUT_FILE_YLOC=30;
const int LABEL_INPUT_FILE_XLOC=20;
const int TEXTBOX_INPUT_FILE_YLOC=50;
const int TEXTBOX_INPUT_FILE_XLOC=25;
const int LABEL_OUTPUT_FILE_YLOC=90;
const int LABEL_OUTPUT_FILE_XLOC=20;
const int TEXTBOX_OUTPUT_FILE_YLOC=110;
const int TEXTBOX_OUTPUT_FILE_XLOC=25;
const int LABEL_RADIOBOX_INST_YLOC=150;
const int LABEL_RADIOBOX_INST_XLOC=20;
const int RADIOBOX_YLOC=170;
const int RADIOBOX_XLOC=20;
const int LABEL_LNSPERPAGE_YLOC=285;
const int LABEL_LNSPERPAGE_XLOC=45;
const int TEXTBOX_LNSPERPAGE_YLOC=280;
const int TEXTBOX_LNSPERPAGE_XLOC=325;
const int LABEL_STARTNUM_YLOC=330;
const int LABEL_STARTNUM_XLOC=20;
const int TEXTBOX_STARTNUM_YLOC=325;
const int TEXTBOX_STARTNUM_XLOC=315;
const int BUTTON_MAKEC_YLOC=380;
const int BUTTON_MAKEC_XLOC=40;
const int BUTTON_CANCEL_YLOC=380;
const int BUTTON_CANCEL_XLOC=275;
const int SEPARATOR_PROGRESS_YLOC=425; //separator line between input area and progress area.
const int SEPARATOR_PROGRESS_XLOC=15; //unused
const int SEPARATOR_LENGTH=380;  //length of the separator length
const int LABEL_PROGRESS_YLOC=440; //unused now
const int LABEL_PROGRESS_XLOC=25; //unused now
const int SCALE_YLOC=430; //was 460
const int SCALE_XLOC=25;
const int LABEL_WORDCOUNT_YLOC=490;
const int LABEL_WORDCOUNT_XLOC=140;
const int TEXTBOX_PROGRESS_YLOC=510;
const int TEXTBOX_PROGRESS_XLOC=160;
const int SEPARATOR_OUTPUT_YLOC=555; //separator line between progress area. & output area
const int SEPARATOR_OUTPUT_XLOC=15; //unused
const int LABEL_OUTWORDSFILE_YLOC=565;
const int LABEL_OUTWORDSFILE_XLOC=15;
const int LABEL_OUTABCFILE_YLOC=565;
const int LABEL_OUTABCFILE_XLOC=215;
const int TEXTBOX_OUTWORDSFILE_YLOC=580;
const int TEXTBOX_OUTWORDSFILE_XLOC=15;
const int TEXTBOX_OUTABCFILE_YLOC=580;
const int TEXTBOX_OUTABCFILE_XLOC=215;


const char *HELP_INFO =
"This is the xconcordancer Help Window
Use the scroll bar  to scroll the window. 

Copyright Notice:
xconcordancer is (c) 2000  by
 
R and R Computing Services,  
39 Nelson Avenue
Monroe Twp., N.J. 08831

under the GPL public license which you 
should have received in this applic-
ation's package. Which, please see.

Purpose: xconcordancer will create a con-
cordance of all the words in a text file, 
providing a readout of each word, its 
length, the number of times it is used in 
the file, and the locations in the file 
concordanced at which the word is found.

METHODS OF LOCATING WORDS:
There are several different ways in which 
the locations of words in a file can be 
determined. 

Locate Words by page using
Formfeeds [default]:

Xconcordancer can locate the words it 
finds by the page they are on using the 
ASCII FormFeed character as the means
of incrementing pages.  Every time a 
FormFeed character (ASCII # 12d*, or 
# OCh**) is found, this method will 
increment the page counter. Using
this method, if no starting page num-
ber has been given (see below), words
before the first FormFeed character
will be considered to have been found
on page 1.  After the 1st FF and before 
the 2nd FF, words found will be listed
as found on page 2, and so forth.
(*d=decimal; **h=hexadecimal)

Locate words by Line:

The second method of locating words 
in a file concordanced is by the line 
they are on.  Every time xconcord-
ancer runs across a LineFeed char-
acter [ASCII # 10d, or 0Ah] using this 
method, it will increment the line 
counter.  The lines in the file on 
which a word is found will be rec-
orded as part of that word\'s 
information.

Locate Words by Stanza Number \"n>\"

The third method of locating words in a 
file is by stanzas, providing that the 
stanza numbers are marked with 
an n> where the \'n\' is the num-
ber of the stanza and it is immed-
iately followed in the file by a 
greater-than sign \'>\'.  These numbers
are not incremented, but are taken 
from the number preceding the 
greater-than sign.

Locate words via paging by Lines
per Page:

The fourth method of locating words in 
a file is by paging using a combination
of line-counting and FormFeed characters.  
In the fourth method, the number of lines 
per page (the default is 60) is counted 
by concordancer, and the page number is 
incremented whenever the number of 
lines per page is passed.  Optionally, 
the number of lines per page to be used 
in counting can be changed from its de-
fault of 60 if desired.


Other options:

Enter first Page/Line Number :

In instances of large files that may need 
to be broken down into several con-
secutive pieces, or in cases of several 
consecutive files, where the beginning 
page or line number in each file is 
other than page 1, counting for either
pages or for lines can begin at a page or 
line other than 1 if the beginning page 
or line number setting is set to other 
than 1.  Changing the beginning page 
or line number works for all methods 
except that of stanza counting which 
depends on the integer preceding the 
greater-than sign for its location 
indicator.

NOTE that the xconcordancer window
is set up so that only the appropriate
entry possibilities will be shown.  For
example, the \'number of lines to
consider a page\' prompt and text box
for entering that number will not
appear unless the radio button
\'Locate words via paging by Lines
per Page\' has been selected.

FILES PRODUCED:
xconcordancer, upon completion, 
writes two files to disk: a filename.wds 
file and a filename.abc file.  The .wds 
file contains the concordanced, alpha-
betized, and located list of words found 
in the file.  The .abc file contains a 
list of the English letters and the per-
centages of the letters' usages in the 
file presented both as a numerical
figure and as a graph.

If no output filename is indicated, the
name of the .wds and .abc files will be 
taken from the name of the input file.
If an output filename is given (doing 
so is optional), the .wds and .abc files
will use that filename.

xconcordancer will indicate the 
progress of concordancing on the
progress slider bar and will show the 
total number of words concordanced 
at the end of a run, along with the 
names of the output .wds and .abc 
files.  These files will be found in the 
directory of the file that has been 
concordanced.  Be warned, however
that you must have permission to
write to the directory in which the
file to be concordanced is located,
otherwise, xconcordancer may
simply give up the ghost when it
finds it cannot properly write the
output files.  There is an assert
command that will kill the program
if the output files can't be written.

If all goes well, xconcordancer will 
put up a dialog box when
 concordancing is completed.  When
the \'OK\' button on this dialog box
is clicked, xconcordancer will reset
itself for the next run, returning
most settings to zero.  So, if you 
want to see the output file names,
be sure to read them before 
clicking the OK button on the
concordancing completed dialog
box!";

#endif
